 /**
 * @author: Mari Carmen Otero
 */

package septiembre;

import javabook.*;

class MiString
{
    //atributos
    private MainWindow ventanaPrincipal;
    private InputBox cuadroEntrada;
    private OutputBox cuadroSalida;
    private MessageBox cuadroMensaje;
    private ResponseBox cuadroRespuesta;
    private String cadena;

    //constructor
    public MiString()
    {
        ventanaPrincipal = new MainWindow();
      	cuadroEntrada = new InputBox (ventanaPrincipal);
      	cuadroSalida = new OutputBox (ventanaPrincipal);
      	cuadroMensaje = new MessageBox (ventanaPrincipal);
      	cuadroRespuesta = new ResponseBox (ventanaPrincipal);
        cadena = new String();
                
      	ventanaPrincipal.setVisible(true);
      	cuadroSalida.show();
    }

    //mtodo empezar
    public void empezar()
    {
      	int respuesta;
      	respuesta = cuadroRespuesta.prompt("Quieres repetir este programa?");

      	while (respuesta == cuadroRespuesta.YES)
      	{
          	leerCadena();
          	mostrarResultados();

          	respuesta = cuadroRespuesta.prompt("Quieres repetir este programa?");
      	}
    }
   //mtodo leerCadena
    private void leerCadena()
    {
        boolean esLongitudCorrecta = true;
        boolean esNoNumerica = true;

        do
        {
            cadena = cuadroEntrada.getString ("Introduce una cadena no numrica: ");

            esLongitudCorrecta = validarLongitud();
            if (esLongitudCorrecta == false)
                cuadroMensaje.show("La longitud de la cadena debe ser como mximo igual a 50. Repetir");

            esNoNumerica = validarDigitosNoNumericos();
            if (esNoNumerica == false)
                cuadroMensaje.show("La cadena no puede tener caracteres numricos. Repetir");
            
        } while (!esLongitudCorrecta || !esNoNumerica);
    }

  	//mtodo validarLongitud
  	private boolean validarLongitud()
  	{
        boolean esCorrecto = true;
        if (cadena.length() > 50)
            esCorrecto = false;
        return esCorrecto;
    }

    //mtodo validarDigitosNoNumericos
    private boolean validarDigitosNoNumericos()
    {
        int i = 0;
        boolean cadenaNoNumerica = true;
  
        while (i < cadena.length() && cadenaNoNumerica)
        {
            if (cadena.charAt(i) >= '0' && cadena.charAt(i) <= '9')
                cadenaNoNumerica = false;
            else
                i++;
        }
        return cadenaNoNumerica;
    }

  	//mtodo subcadAsciiPar
  	private String subcadAsciiPar()
  	{
        String subcadenaPar = new String();
        for (int i = 0; i < cadena.length(); i++) 
        {
            char letra = cadena.charAt(i); 
            int codigo = (int) letra;
            if (codigo % 2 == 0)
              subcadenaPar = subcadenaPar + letra;
        }
        return subcadenaPar;
    }

    //mtodo subcadAsciiImpar
  	private String subcadAsciiImpar()
  	{
        String subcadenaImpar = new String();
        for (int i = 0; i < cadena.length(); i++) 
        {
            char letra = cadena.charAt(i); 
            int codigo = (int) letra;
            if (codigo % 2 != 0)
              subcadenaImpar = subcadenaImpar + letra;
        }
        return subcadenaImpar;
    }

    //mtodo contVocales
  	private int contVocales()
  	{
        int total = 0;
        for (int i = 0; i < cadena.length(); i++) 
        {
            char letra = cadena.charAt(i); 
            if (letra == 'A' || letra == 'a' ||
                letra == 'E' || letra == 'e' ||
                letra == 'I' || letra == 'i' ||
                letra == 'O' || letra == 'o' ||
                letra == 'U' || letra == 'u')
                total = total + 1;
        }
        return total;
    }

    //mtodo sumCodigosAscii
  	private int sumCodigosAscii()
  	{
        int total = 0;
        for (int i = 0; i < cadena.length(); i++) 
        {   
            char letra = cadena.charAt(i); 
            if (letra >= 'A' && letra <= 'Z' || letra == '')
            {
                int codigo = (int) letra;
                total = total + codigo;
            }
        }
        return total;
    }

    //mtodo mostrarResultados
    private void mostrarResultados()
    {
      cuadroSalida.printLine ("Cadena Tecleada:  " + cadena);
      cuadroSalida.skipLine(2);
      cuadroSalida.printLine ("Subcadena   Par:  " + subcadAsciiPar());
      cuadroSalida.printLine ("Subcadena Impar:  " + subcadAsciiImpar());
      cuadroSalida.printLine ("Nmero  Vocales:  " + contVocales());
      cuadroSalida.printLine ("Suma Maysculas:  " + sumCodigosAscii());
    }

}